jQuery(document).ready(function($){
	
	window.eShopDynamicStates = window.eShopDynamicStates || {};
	
	
	/**
	 *  @package eShopDynamicStates
	 *  @desc    Refreshes the states fields 
	 */
	eShopDynamicStates.refresh_states = function(country_code,target_field,prequel,sequel) {
		
		var data = {
			    country_code: country_code,
			    action: eShopDynamicStates.ajaxaction
		};
		
		if (prequel){
			prequel();
		}
		
		$.ajax({
				type    : eShopDynamicStates.method,
				url     : eShopDynamicStates.ajaxurl,
				data    : data,
				dataType: 'json',			
				success : function(ajax_response){
					if (sequel) {
						sequel(ajax_response);
					}
				}
		});
		
	};
	
	
	/**
	 *  @package eShopDynamicStates
	 *  @desc    Replaces the select field with text input and vice-versa according to ajax data 
	 */
	eShopDynamicStates.replace_field = function(jtarget,data){
		var name = jtarget.attr('name'), 
		    id   = jtarget.attr('id'),
		    classNames = jtarget.attr('class'),
		    has_elements = 0,
		    replace;
		
		for (i in data) {
			if (data.hasOwnProperty(i)){
				has_elements++;
				break;
			}
		}

		if (has_elements) {
			replace = $("<select>",{name:name,id:id,class:classNames});
			// Create dropdown options
			$.each(data, function(key, value) {
				replace
			          .append($('<option>', {value:value})
			          .text(key));
			});
		}
		else {
			replace = $("<input type=\"text\" name=\""+name+"\" id=\""+id+"\" class=\""+classNames+"\">");
		}
		
		jtarget.replaceWith(replace);
	};
	
	
	/**
	 *  @package eShopDynamicStates
	 *  @var     obj jQuery object being clicked
	 *  @desc    Wrapper for replace_field 
	 */
	eShopDynamicStates.do_action = function(obj) {
		
		var country_code = obj.val(),
		id = obj.attr('id'),
	    target_field,prequel,sequel;
	
		target_field = (id == 'country') ? $('#state') : $('#shipstate'); 
	
		prequel = function(){
			$('#usc_dyn_states_throbber_from_' + id).show();
		};
	
		sequel = function(ajaxresponse){
			$('#usc_dyn_states_throbber_from_' + id).hide();
			eShopDynamicStates.replace_field(target_field,ajaxresponse.data);
		};
	
		eShopDynamicStates.refresh_states(country_code,target_field,prequel,sequel);
	};
	
	
	
	// Move country to before State
	if ($('span.state')) {
		
		$('span.state').before($('span.country'));

		$('span.state').append($('<img />',{src: eShopDynamicStates.includes_url + '/arrows-throbber.gif', 
			id : 'usc_dyn_states_throbber_from_country', 
			style: 'float: right; display:none'}));
	}
	
	if ($('span.ship_state')) {
		
		$('span.ship_state').before($('span.shipcountry'));

		$('span.ship_state').append($('<img />',{src: eShopDynamicStates.includes_url + '/arrows-throbber.gif', 
			id : 'usc_dyn_states_throbber_from_shipcountry', 
			style: 'float: right; display:none'}));
	}
	
	
	// Remove original altstate and ship_altstate
	$('span.altstate,span.ship_altstate').remove();
	
	// Rename state and ship_state
	$('#state').attr('name','altstate');
	$('#shipstate').attr('name','ship_altstate');
	
	
	// Tie events
	$('#country,#shipcountry').change(function(){
		eShopDynamicStates.do_action($(this));
	});
	
	
	// Kick off process on load
	(function(){
		if ($('#country')) {
			eShopDynamicStates.do_action($('#country'));
		}
		
		if ($('#shipcountry')) {
			eShopDynamicStates.do_action($('#shipcountry'));
		}
	})();
	
	
	
});